// ChildView.cpp : CChildView Ŭ 
//
#include "stdafx.h"
#include "Osim.h"
#include ".\childview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define range(a,b,c) ( (a)<(c) ? ((a)<=(b) && (b)<=(c)):((c)<=(b) && (b)<=(a)))
#define fixequal(a,b) (( (a)>(b) ? (a)-(b):(b)-(a))<0.0001)

template<typename T> void swap(T& a, T& b) { T c; c=a; a=b; b=c; }

//-1 , 0      ʴ, 1    ִ
int CDblPoint::Meet(CDblPoint lfrom, CDblPoint lto, CDblPoint mfrom, CDblPoint mto, CDblPoint& out)
{
	double ea,eb,ec,ed, ee=mfrom.x,eg=mto.x,ef=mfrom.y,eh=mto.y;
	if (lfrom.x!=lto.x && mfrom.x!=mto.x) {
		ea=(lto.y-lfrom.y)/(lto.x-lfrom.x), eb=lto.y-lto.x*ea,
		ec=(mto.y-mfrom.y)/(mto.x-mfrom.x), ed=mto.y-mto.x*ec;
		if (ea==ec) return -1;
		out.x=(ed-eb)/(ea-ec), out.y=ea*out.x+eb;
	}
	else {
		if(lfrom.x==lto.x && mfrom.x==mto.x) return -1;
		if(mfrom.x==mto.x) {
			swap(lfrom.x, mfrom.x); swap(lfrom.y, mfrom.y);
			swap(lto.x, mto.x); swap(lto.y, mto.y);
		}
		ec=(mto.y-mfrom.y)/(mto.x-mfrom.x), ed=mto.y-mto.x*ec;
		out.x=lfrom.x; out.y=lfrom.x*ec+ed;
	}
	return range(ee, out.x, eg) && range(ef, out.y, eh);
}

CDblPoint CDblPoint::DivideTwo(CDblPoint a, const CDblPoint& b)
{
	double rati=b.Distance()/a.Distance(); a*=rati;
	return CDblPoint((a.x+b.x)/2, (a.y+b.y)/2);
}

// CChildView
CChildView::CChildView(): m_bDetailed(TRUE), m_nDrawFlag(3), m_nNumFlags(2),
	m_RcSize(0,0,0,0), m_sizeDC(0,0), m_pCurBmp(NULL), m_pOldBmp(NULL) //virtual bitmap
{
	m_Pt[0]=CDblPoint(380, 100);
	m_Pt[1]=CDblPoint(100, 285);
	m_Pt[2]=CDblPoint(450, 285);
}

CChildView::~CChildView()
{
}

BEGIN_MESSAGE_MAP(CChildView, CWnd)
	ON_WM_PAINT()
	ON_COMMAND(ID_DETAILED, OnDetailed)
	ON_COMMAND(ID_CLEAR_ALL, OnClearAll)
	ON_COMMAND_RANGE(ID_INNERCENTER, ID_NAPOLEON_TRIANGLE, OnCenters)
	ON_UPDATE_COMMAND_UI_RANGE(ID_INNERCENTER, ID_NAPOLEON_TRIANGLE, OnUpdateCenters)
	ON_UPDATE_COMMAND_UI(ID_DETAILED, OnUpdateDetailed)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_SIZE()
END_MESSAGE_MAP()

// CChildView ޽ ó
BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs)) return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), reinterpret_cast<HBRUSH>(COLOR_WINDOW+1), NULL);
	return TRUE;
}

void CChildView::OnPaint() 
{
	CPaintDC dc(this); CRect rc(dc.m_ps.rcPaint);
	dc.BitBlt(rc.left, rc.top, rc.Width(), rc.Height(), &m_SrcDC, rc.left, rc.top, SRCCOPY);
}

void CChildView::Redraw()
{
	CDblPoint op, os; CFont ft, *of;
	m_bLarge = fabs(CDblPoint::GetProduct(m_Pt[0], m_Pt[1], m_Pt[2])) > 720*720;
	m_SrcDC.SelectStockObject(NULL_BRUSH); m_SrcDC.SetBkMode(TRANSPARENT);
	ft.CreateFont(m_bLarge ? 24:18, 0,0,0,FW_BOLD, FALSE,FALSE,0,DEFAULT_CHARSET,
		OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH, _T("Arial"));
	of=m_SrcDC.SelectObject(&ft);
	m_SrcDC.FillSolidRect(0, 0, m_sizeDC.cx, m_sizeDC.cy, RGB(255,255,255)); //white screen
	if(m_nDrawFlag&1) Naesim(m_SrcDC); if(m_nDrawFlag&2) Oisim(m_SrcDC, &op);
	if(m_nDrawFlag&4) Mugejungsim(m_SrcDC); if(m_nDrawFlag&8) Bangsim(m_SrcDC);
	if(m_nDrawFlag&16) Susim(m_SrcDC, &os); if(m_nDrawFlag&32) NineCenter(m_SrcDC);
	if(m_nDrawFlag&64) NapoleonTriangle(m_SrcDC);
	RenderTriangle(m_SrcDC);
	if( (m_nDrawFlag&(16|2))==(16|2) && (m_nDrawFlag&(4|32)) ) { //ܽɰ   Ϸ 
		CPen pen(PS_DASH, 1, euilerLColor), *olp;
		olp=m_SrcDC.SelectObject(&pen);
		Line(m_SrcDC, op, os);
		m_SrcDC.SelectObject(olp);
	}
	m_SrcDC.SelectObject(&of);

	CClientDC dc(this);
	dc.BitBlt(0, 0, m_RcSize.Width(), m_RcSize.Height(), &m_SrcDC, 0, 0, SRCCOPY);
}

void CChildView::PrepareRect(const CDblPoint& nae, CRect& rc)
{
	rc.top=(int)nae.y+5; rc.bottom=rc.top+30; rc.left=(int)nae.x-30; rc.right=rc.left+60;
}

// : ﰢ   ̵м 
void CChildView::Naesim(CDC& dc)
{
	CPen pen(PS_SOLID, 1, naesimColor), pen2(PS_DOT, 1, naesimColor), *op;
	CDblPoint divd1, divd2, nae; double dist;
	op=dc.SelectObject(&pen);

	divd1=CDblPoint::DivideTwo(m_Pt[0]-m_Pt[1], m_Pt[2]-m_Pt[1]); //1  
	divd2=CDblPoint::DivideTwo(m_Pt[0]-m_Pt[2], m_Pt[1]-m_Pt[2]); //2  
	CDblPoint::Meet(m_Pt[1], m_Pt[1]+divd1, m_Pt[2], m_Pt[2]+divd2, nae);
	Circle(dc, nae, 4); // 
	if(m_nNumFlags>2) { CRect rc; PrepareRect(nae, rc); dc.DrawText(_T("I"), rc, DT_CENTER); }

	CDblPoint::Meet(nae, nae+(m_Pt[2]-m_Pt[1]).Soojik(), m_Pt[1], m_Pt[2], divd1);
	dist=CDblPoint::Distance(divd1, nae); // 1-2     Ÿ
	Circle(dc, nae, dist); //ɿ

	if(m_bDetailed) {
		Line(dc, divd1, nae);
		CDblPoint::Meet(nae, nae+(m_Pt[2]-m_Pt[0]).Soojik(), m_Pt[0], m_Pt[2], divd1);
		Line(dc, divd1, nae);
		CDblPoint::Meet(nae, nae+(m_Pt[1]-m_Pt[0]).Soojik(), m_Pt[0], m_Pt[1], divd1);
		Line(dc, divd1, nae); //  

		dc.SelectObject(&pen2); // 
		Line(dc, m_Pt[0], nae); Line(dc, m_Pt[1], nae); Line(dc, m_Pt[2], nae);
	}
	dc.SelectObject(op);
}

// : ﰢ   ̵м 
void CChildView::Oisim(CDC& dc, CDblPoint *p)
{
	CPen pen(PS_SOLID, 1, oisimColor), pen2(PS_DOT, 1, oisimColor), *op;
	CDblPoint divd1, divd2, oi;
	op=dc.SelectObject(&pen);

	divd1=CDblPoint::Center(m_Pt[0], m_Pt[1]); divd2=CDblPoint::Center(m_Pt[0], m_Pt[2]);
	CDblPoint::Meet(divd1, divd1+(m_Pt[0]-m_Pt[1]).Soojik(),
		divd2, divd2+(m_Pt[2]-m_Pt[0]).Soojik(), oi);
	Circle(dc, oi, 4); // 
	if(p) *p=oi;
	if(m_nNumFlags>2) { CRect rc; PrepareRect(oi, rc); dc.DrawText(_T("O"), rc, DT_CENTER); }

	Circle(dc, oi, CDblPoint::Distance(oi, m_Pt[0])); //ܽɿ

	if(m_bDetailed) {
		Line(dc, m_Pt[0], oi); Line(dc, m_Pt[1], oi); Line(dc, m_Pt[2], oi);
		dc.SelectObject(&pen2); // 
		Line(dc, CDblPoint::Center(m_Pt[0], m_Pt[1]), oi);
		Line(dc, CDblPoint::Center(m_Pt[0], m_Pt[2]), oi);
		Line(dc, CDblPoint::Center(m_Pt[1], m_Pt[2]), oi);
	}
	dc.SelectObject(op);
}

//߽:  ߼ 
//(߼: ﰢ  ,   뺯 شϴ    )
void CChildView::Mugejungsim(CDC& dc)
{
	CPen pen(PS_SOLID, 1, mugeColor), pen2(PS_DOT, 1, mugeColor), *op;
	CDblPoint mu;
	op=dc.SelectObject(&pen);

	mu=CDblPoint((m_Pt[0].x+m_Pt[1].x+m_Pt[2].x)/3, (m_Pt[0].y+m_Pt[1].y+m_Pt[2].y)/3);
	Circle(dc, mu, 4); //߽  ϱ 
	if(m_nNumFlags>2) { CRect rc; PrepareRect(mu, rc); dc.DrawText(_T("G"), rc, DT_CENTER); }

	dc.SelectObject(&pen2); //߼ ׸
	Line(dc, m_Pt[0], CDblPoint::Center(m_Pt[1], m_Pt[2]));
	if(m_bDetailed) {
		Line(dc, m_Pt[1], CDblPoint::Center(m_Pt[0], m_Pt[2]));
		Line(dc, m_Pt[2], CDblPoint::Center(m_Pt[0], m_Pt[1]));
	}
	dc.SelectObject(op);
}

//: ﰢ   ̵м 
void CChildView::Bangsim(CDC& dc)
{
	CPen pen(PS_SOLID, 1, bangColor), pen2(PS_DOT, 1, bangColor), *op=dc.GetCurrentPen();
	CDblPoint divd1, divd2, bang; double dist; int i, p1, p2;

	for(i=0;i<3;i++) { //  
		dc.SelectObject(&pen); p1=(i+1)%3, p2=(i+2)%3;
		// ܰ ̵м Ѵ
		divd1=CDblPoint::DivideTwo(m_Pt[p1]-m_Pt[i], m_Pt[p2]-m_Pt[p1]);
		divd2=CDblPoint::DivideTwo(m_Pt[p2]-m_Pt[i], m_Pt[p1]-m_Pt[p2]);
		CDblPoint::Meet(m_Pt[p1], m_Pt[p1]+divd1, m_Pt[p2], m_Pt[p2]+divd2, bang);
		Circle(dc, bang, 4); // ǥ 

		CDblPoint::Meet(m_Pt[p1], m_Pt[p2], bang, bang+(m_Pt[p2]-m_Pt[p1]).Soojik(), divd1);
		dist=CDblPoint::Distance(divd1, bang);
		Circle(dc, bang, dist); //

		if(m_bDetailed) {
			Line(dc, divd1, bang); //  
			CDblPoint::Meet(m_Pt[i], m_Pt[p1], bang, bang+(m_Pt[p1]-m_Pt[i]).Soojik(), divd1);
			Line(dc, divd1, bang);
			CDblPoint::Meet(m_Pt[i], m_Pt[p2], bang, bang+(m_Pt[p2]-m_Pt[i]).Soojik(), divd2);
			Line(dc, divd2, bang);
			dc.SelectObject(&pen2);
			Line(dc, m_Pt[p1], divd1); Line(dc, m_Pt[p2], divd2);
			Line(dc, m_Pt[i], bang);
		}
	}
	dc.SelectObject(op);
}

//: ﰢ    뺯     
void CChildView::Susim(CDC& dc, CDblPoint *p)
{
	CPen pen(PS_SOLID, 1, susimColor), pen2(PS_DOT, 1, susimColor), *op;
	CDblPoint divd, su;
	op=dc.SelectObject(&pen);

	CDblPoint::Meet(m_Pt[0], m_Pt[0]+(m_Pt[2]-m_Pt[1]).Soojik(), m_Pt[1],
		m_Pt[1]+(m_Pt[0]-m_Pt[2]).Soojik(), su);
	Circle(dc, su, 4); // 
	if(p) *p=su;
	if(m_nNumFlags>2) { CRect rc; PrepareRect(su, rc); dc.DrawText(_T("H"), rc, DT_CENTER); }

	dc.SelectObject(&pen2); // ׸
	if(GetTriangleType()>0) {
		int i, longest; double sd, longdist=-1;
		//аﰢ  ۿ ִµ,  ߸    ƿ ٸ 
		//  ׸.
		for(i=0;i<3;i++) { //   ϰ
			sd=CDblPoint::Distance(m_Pt[i], m_Pt[(i+1)%3]);
			if(sd>longdist) longdist=sd, longest=i;
		}
		CDblPoint::Meet(su, su+(m_Pt[longest]-m_Pt[(longest+1)%3]).Soojik(),
			m_Pt[longest], m_Pt[(longest+1)%3], divd);
		Line(dc, su, divd);
		if(m_bDetailed) {
			Line(dc, su, m_Pt[longest]); Line(dc, su, m_Pt[(longest+1)%3]);
		}
	}
	else {
		// ﰢ ȿ Ƿ   ׸.
		CDblPoint::Meet(m_Pt[0], m_Pt[0]+(m_Pt[1]-m_Pt[2]).Soojik(), m_Pt[1], m_Pt[2], divd);
		Line(dc, m_Pt[0], divd);
		if(m_bDetailed) {
			CDblPoint::Meet(m_Pt[1], m_Pt[1]+(m_Pt[0]-m_Pt[2]).Soojik(), m_Pt[0], m_Pt[2], divd);
			Line(dc, m_Pt[1], divd);
			CDblPoint::Meet(m_Pt[2], m_Pt[2]+(m_Pt[0]-m_Pt[1]).Soojik(), m_Pt[0], m_Pt[1], divd);
			Line(dc, m_Pt[2], divd);
		}
	}
	dc.SelectObject(op);
}

void CChildView::NineCenter(CDC& dc)
{
	CPen pen(PS_SOLID, 1, ninceColor), *op;
	op=dc.SelectObject(&pen);

	CDblPoint divd1, divd2, oi;
	CDblPoint v[3]; int i;
	for(i=0; i<3; i++) v[i] = (m_Pt[i] + m_Pt[(i+1)%3])*0.5;
	divd1=CDblPoint::Center(v[0], v[1]); divd2=CDblPoint::Center(v[0], v[2]);
	CDblPoint::Meet(divd1, divd1+(v[0]-v[1]).Soojik(),
		divd2, divd2+(v[2]-v[0]).Soojik(), oi);
	Circle(dc, oi, 4);
	Circle(dc, oi, CDblPoint::Distance(oi, v[0]));
	if(m_nNumFlags>2) { CRect rc; PrepareRect(oi, rc); dc.DrawText(_T("N"), rc, DT_CENTER); }

	if(m_bDetailed) {
		CDblPoint::Meet(m_Pt[0], m_Pt[0]+(m_Pt[2]-m_Pt[1]).Soojik(), m_Pt[1],
			m_Pt[1]+(m_Pt[0]-m_Pt[2]).Soojik(), divd1); //
		for(i=0; i<3; i++) {
			Circle(dc, v[i],4); //  
			CDblPoint::Meet(m_Pt[i], m_Pt[i]+(m_Pt[(i+1)%3]-m_Pt[(i+2)%3]).Soojik(),
				m_Pt[(i+1)%3], m_Pt[(i+2)%3], oi); //뺯  
			Circle(dc, oi, 4);
			Circle(dc, (m_Pt[i] + divd1)*0.5, 4);
		}

	}
	dc.SelectObject(op);
}

void CChildView::NapoleonTriangle(CDC& dc)
{
	int i, j; CDblPoint tri[3];
	BOOL bNegative = CDblPoint::GetProduct(m_Pt[0], m_Pt[1], m_Pt[2]) < 0;
	CPen pen2(PS_DOT, 1, mugeColor), *op;
	op = dc.SelectObject(&pen2);
	for(i=0;i<3;i++) { //  
		j=(i+1)%3;
		CDblPoint br( (m_Pt[j]-m_Pt[i]).Soojik()*(sqrt(3.0)/2.0) ); //sin 60..
		CDblPoint ct( CDblPoint::Center(m_Pt[i], m_Pt[j]) );
		if(bNegative) ct-=br; else ct+=br;
		if(m_bDetailed) { Line(dc, ct, m_Pt[i]); Line(dc, ct, m_Pt[j]); }
		tri[i].x = (m_Pt[i].x+m_Pt[j].x+ct.x)/3.0; tri[i].y = (m_Pt[i].y+m_Pt[j].y+ct.y)/3.0;
	}
	for(i=0;i<3;i++) Line(dc, tri[i], tri[(i+1)%3]);
	dc.SelectObject(op);
}

void CChildView::RenderTriangle(CDC& dc)
{
	CPen pen(PS_SOLID, (m_bLarge ? 2: 1), RGB(0,0,0)), *op;
	op=dc.SelectObject(&pen);
	Line(dc, m_Pt[0], m_Pt[1]); Line(dc, m_Pt[1], m_Pt[2]); Line(dc, m_Pt[2], m_Pt[0]);
	if(m_bDetailed) { // ǥ  Ѵ
		dc.SelectStockObject(BLACK_PEN);
		Circle(dc, m_Pt[0], 4); Circle(dc, m_Pt[1], 4); Circle(dc, m_Pt[2], 4);
	}
	dc.SelectObject(op);
}

double CChildView::GetTriangleType() const
{
	double dist[3]; int i;
	for(i=0;i<3;i++) dist[i]=CDblPoint::Distance(m_Pt[i], m_Pt[(i+1)%3]);
	for(i=0;i<2;i++) //   dist[2]  Ѵ.
		if(dist[i]>dist[(i+1)%3] && dist[i]>dist[(i+2)%3]) swap(dist[i], dist[2]);
	return dist[2]*dist[2]-dist[1]*dist[1]-dist[0]*dist[0];
}

void CChildView::OnDetailed()
{
	m_bDetailed^=1; Redraw();
}

void CChildView::OnUpdateDetailed(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bDetailed);
}

void CChildView::OnCenters(UINT nID)
{
	m_nDrawFlag^=1<<(nID-ID_INNERCENTER);
	int i; for(i=m_nNumFlags=0; i<6; i++) if(m_nDrawFlag&(1<<i)) m_nNumFlags++;
	Redraw();
}

void CChildView::OnUpdateCenters(CCmdUI *pCmdUI)
{
	//SetCheckδ 0 ƴϸ 1  ϹǷ !! ó .
	pCmdUI->SetCheck(!!(m_nDrawFlag&(1<<(pCmdUI->m_nID-ID_INNERCENTER)) ));
}

void CChildView::OnLButtonDown(UINT nFlags, CPoint point)
{
	int i; for(i=0;i<3;i++) if(CDblPoint::Distance(point, m_Pt[i])<=6) break;
	if(i<3) { m_nHolding=i; SetCapture(); }
	else {
		CDblPoint d(point); int n=_CSW(m_Pt[0], m_Pt[1], m_Pt[2]);
		//콺 Ͱ ﰢ ο ִ°?
		if(_CSW(m_Pt[1], d, m_Pt[0])==n && _CSW(m_Pt[2], d, m_Pt[1])==n &&
			_CSW(m_Pt[0], d, m_Pt[2])==n) {
			m_ptLastPos = point; m_nHolding=-1; SetCapture();
		}
	}
}

void CChildView::OnLButtonUp(UINT nFlags, CPoint point)
{
	if(GetCapture()==this) ReleaseCapture();
}

void CChildView::OnMouseMove(UINT nFlags, CPoint point)
{
	if(GetCapture()==this) {
		if(m_nHolding==-1) { //ﰢ ü ̵
			CDblPoint dp(point.x-m_ptLastPos.x, point.y-m_ptLastPos.y);
			for(int i=0;i<3;i++) m_Pt[i] += dp; m_ptLastPos=point;
		}
		else m_Pt[m_nHolding]=point; //  ̵
		Redraw();
	}
}

void CChildView::OnSize(UINT nType, int cx, int cy)
{
	if(GetSafeHwnd()) {
		if(cx>m_sizeDC.cx || cy>m_sizeDC.cy) {
			CClientDC r(this);
			m_sizeDC.cx=max(m_sizeDC.cx, cx); m_sizeDC.cy=max(m_sizeDC.cy, cy);
			if(m_pCurBmp) delete m_pCurBmp;
			else {
				m_SrcDC.CreateCompatibleDC(&r);
				m_pOldBmp=m_SrcDC.GetCurrentBitmap();
			}
			m_pCurBmp=new CBitmap;
			m_pCurBmp->CreateCompatibleBitmap(&r, m_sizeDC.cx, m_sizeDC.cy);
			m_SrcDC.SelectObject(m_pCurBmp);
		}
		m_RcSize.right=cx, m_RcSize.bottom=cy;
		if(cx>0 && cy>0) Redraw();
	}
}

void CChildView::OnClearAll()
{
	if(m_nDrawFlag) { m_nDrawFlag=0; Redraw(); }
}
