// ChildView.h : CChildView Ŭ ̽
//
#pragma once
#include <math.h>
class CDblPoint {
public:
	CDblPoint() {}
	CDblPoint(double a, double b): x(a), y(b) {}
	CDblPoint(const POINT& a): x(a.x), y(a.y) {}
	double x,y;

	//primitive operation
	CDblPoint operator-(const CDblPoint& p) { CDblPoint a(x-p.x, y-p.y); return a; }
	CDblPoint operator+(const CDblPoint& p) { CDblPoint a(x+p.x, y+p.y); return a; }
	CDblPoint operator*(double p) { CDblPoint a(p*x, p*y); return a; }
	const CDblPoint& operator-=(const CDblPoint& p) { y-=p.y, x-=p.x; return *this; }
	const CDblPoint& operator+=(const CDblPoint& p) { y+=p.y, x+=p.x; return *this; }
	const CDblPoint& operator*=(double p) { y*=p, x*=p; return *this; }

	//attributes
	double Distance() const { return sqrt(x*x+y*y); } //vector
	CDblPoint Soojik() const { return CDblPoint(y, -x); } //vector
	CDblPoint Opposite() const { return CDblPoint(-y, -x); } //vector
	static CDblPoint Center(const CDblPoint& a, const CDblPoint& b) // ab 
	{ return CDblPoint((a.x+b.x)/2, (a.y+b.y)/2); }
	static double Distance(const CDblPoint& a, const CDblPoint& b) //  Ÿ
	{ return sqrt((b.y-a.y)*(b.y-a.y)+(b.x-a.x)*(b.x-a.x)); }
	static double GetProduct(const CDblPoint& a, const CDblPoint& b, const CDblPoint& c)
	{ return (c.x-b.x)*(a.y-b.y) - (c.y-b.y)*(a.x-b.x); } // ﰢ ̿ (ȣ)

	//advanced attributes
	// a, b   ̰ ̵ϴ ͸ Ѵ.
	static CDblPoint DivideTwo(CDblPoint a, const CDblPoint& b); // vector  ̵ 
	// l, m 
	static int Meet(CDblPoint lfrom, CDblPoint lto, CDblPoint mfrom, CDblPoint mto, CDblPoint& out);
};

// CChildView â
class CChildView : public CWnd {
// 
public:
	CChildView();

// Ư
protected:
	CDblPoint m_Pt[3]; BOOL m_bDetailed; int m_nDrawFlag; //׸ ɼ
	int m_nNumFlags; bool m_bLarge; //׸ 
	int m_nHolding; CPoint m_ptLastPos; //콺 巡 

	//virtual bitmap .   3 ׷ ÿ α׷ .
	CDC m_SrcDC; CSize m_sizeDC; CBitmap *m_pOldBmp, *m_pCurBmp; CRect m_RcSize;
	void Redraw();
	static void PrepareRect(const CDblPoint& x, CRect& r);
	static int _CSW(const CDblPoint& a, const CDblPoint& b, const CDblPoint& c) {
		double t = CDblPoint::GetProduct(a,b,c); return t>0.001 ? 1: t<-0.001 ? -1: 0;
	}

// ۾
public:
	enum KindColor {
		naesimColor=RGB(0,160,64), //ʷ
		oisimColor=RGB(255,0,128), //ȫ
		mugeColor=RGB(168,168,84), //Ȳ
		bangColor=RGB(144,144,144), //ȸ
		susimColor=RGB(0,128,255), //Ķ
		ninceColor=RGB(255,128,0), //Ȳ
		euilerLColor=RGB(128,0,255) //
	};

	//GDI drawing helper
	void Circle(CDC& dc, const CDblPoint& pt, double rad) //helper
	{ dc.Ellipse((int)(pt.x-rad), (int)(pt.y-rad), (int)(pt.x+rad), (int)(pt.y+rad)); }
	void Line(CDC& dc, const CDblPoint& p1, const CDblPoint& p2)
	{ dc.MoveTo((int)p1.x, (int)p1.y); dc.LineTo((int)p2.x, (int)p2.y); }

	//main operation
	void RenderTriangle(CDC& dc);
	void Naesim(CDC& dc);
	void Oisim(CDC& dc, CDblPoint *p=NULL);
	void Mugejungsim(CDC& dc);
	void Bangsim(CDC& dc);
	void Susim(CDC& dc, CDblPoint *p=NULL);
	void NineCenter(CDC& dc);
	void NapoleonTriangle(CDC& dc);

	double GetTriangleType() const; //ﰢ (-1)/ 0/а 1

// 
protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);

// 
public:
	virtual ~CChildView();

	// ޽  Լ ߽ϴ.
protected:
	afx_msg void OnPaint();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnDetailed();
	afx_msg void OnUpdateDetailed(CCmdUI *pCmdUI);
	afx_msg void OnCenters(UINT nID);
	afx_msg void OnUpdateCenters(CCmdUI *pCmdUI);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnClearAll();
};

